/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package adder;

/**
 *
 * @author bellini
 */
public class Adder extends Thread {

    private int[] v;
    private int start;
    private int end;
    private int sum;
    
    public Adder(int[] v,int start, int end) {
       this.v=v;
       this.start = start;
       this.end=end;
    }
    
    public void run() {
        sum = 0;
        for(int i=start; i<=end; i++)
            sum+=v[i];
        System.out.println("somma parziale start: "+ start+" end: "+end+" sum: "+sum);
    }
    
    public int getSum() {
        return sum;
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        int[] values=new int[10000];
        for(int i=0; i<values.length; i++)
            values[i]=i;
        
        Adder[] threads = new Adder[7];
        int nv = values.length/threads.length;
        
        for(int j=0; j<threads.length; j++) {
            threads[j]=new Adder(values,j*nv,(j+1)*nv-1+
                    (j==threads.length-1 ? 
                            values.length%threads.length : 0));
            threads[j].start();
        }
        try {
            int s = 0;
            for(int j=0; j<threads.length; j++) {
                threads[j].join();
                s+= threads[j].getSum();
            }
            System.out.println("somma totale: "+s);
        } catch(InterruptedException ex) {
        }
    }
    
}
