/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package countthread;

import java.util.concurrent.atomic.AtomicIntegerArray;

/**
 *
 * @author bellini
 */
public class CountThread extends Thread {

    private static int count = 0;
    //Peterson
    private static volatile int turn=0;
    private static volatile boolean flag[]=new boolean[2];
    //Lamport
    private static AtomicIntegerArray choosing=new AtomicIntegerArray(2);
    private static AtomicIntegerArray number=new AtomicIntegerArray(2);
    private int id;

    public CountThread(int id) {
        this.id = id;
    }
    
    public void run() {
        int j = 1-id; //altro thread
        for(int i=0; i<100000; i++) {
    
            //Peterson due thread
            flag[id] = true;
            turn=j;
            while(flag[j] && turn==j) {
            }
            
            /*//Lamport per due thread
            choosing.set(id,1);
            number.set(id, 1+number.get(j));
            choosing.set(id,0);
            while(choosing.get(j)==1){}
            while(number.get(j)!=0 && 
                    (number.get(j)<number.get(id) || 
                    (number.get(j)==number.get(id) && j<id))) {
            }*/
            count++;
            flag[id] = false; //Peterson
            //number.set(id,0); //Lamport
        }
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        CountThread th1=new CountThread(0);
        CountThread th2=new CountThread(1);
        
        th1.start();
        th2.start();
        try {
            th1.join();
            th2.join();
        } catch(InterruptedException ex) {
        }
        System.out.println("count="+count);
    }
}
