/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package philosophers;

import java.util.concurrent.Semaphore;

/**
 *
 * @author bellini
 */
public class TableWithSemaphores implements PhilosophersTable{

    private Semaphore[] chopsticks;
    
    public TableWithSemaphores(int nPhilosophers) {
        chopsticks = new Semaphore[nPhilosophers];
        for(int i=0; i<nPhilosophers; i++)
            chopsticks[i]=new Semaphore(1);
    }
    
    @Override
    public void getChopsticks(int i) throws InterruptedException {
        chopsticks[i].acquire();
        chopsticks[(i+1)%chopsticks.length].acquire();
    }

    @Override
    public void putChopsticks(int i) {
        chopsticks[i].release();
        chopsticks[(i+1)%chopsticks.length].release();
    }
    
}
