/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package philosophers;

/**
 *
 * @author bellini
 */
public class TableWithSynch implements PhilosophersTable {

    private int state[];
    static final int EAT = 0;
    static final int HUNGRY = 1;
    static final int THINK = 2;
    
    public TableWithSynch(int nPhilosophers) {
        state = new int[nPhilosophers];
        for(int i=0; i<nPhilosophers; i++)
            state[i]=THINK;
    }
    
    @Override
    public synchronized void getChopsticks(int i) throws InterruptedException {
        state[i]=HUNGRY;
        while(state[(i+1)%state.length]==EAT || 
                state[(i+state.length-1)%state.length]==EAT)
            wait();
        state[i]=EAT;
        notifyAll();
    }

    @Override
    public synchronized void putChopsticks(int i) {
        state[i]=THINK;
        notifyAll();
    }
    
}
