/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package producerconsumer;

/**
 *
 * @author bellini
 */
public class ProducerConsumer {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        SharedBuffer buffer=new SharedBufferWithSynch(1);//new SharedBufferWithSemaphores(5);
        new Producer(buffer, "P1").start();
        new Consumer(buffer, "C1").start();
        new Consumer(buffer, "C2").start();
    }
    
}

class Producer extends Thread {
    private SharedBuffer buffer;
    
    public Producer(SharedBuffer b, String name) {
        super(name);
        buffer=b;
    }
    
    @Override
    public void run() {
        try {
            int i=0;
            do {
                buffer.add(i++); //boxing
                System.out.println(getName()+": prodotto "+(i-1));
                //Thread.sleep((long)(1000*Math.random()));
            } while(true);
        } catch(InterruptedException e) {
        }
    }
}

class Consumer extends Thread {
    private SharedBuffer buffer;
    
    public Consumer(SharedBuffer b, String name) {
        super(name);
        buffer=b;
    }
    
    public void run() {
        try {
            do {
                Object o=buffer.remove();
                System.out.println(getName()+": consumo "+o);
                //Thread.sleep((long)(1000*Math.random()));
            }while(true);
        } catch(InterruptedException e) {
            
        }      
    }
}
