/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package readerwriter;

/**
 *
 * @author bellini
 */
public class ReaderWriter {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        //DatabaseAccess dba=new DatabaseAccesWithSemaphore();
        DatabaseAccess dba=new DatabaseAccessWithSynch();
        new Writer(dba,"W1").start();
        new Writer(dba,"W2").start();
        new Reader(dba,"R1").start();
        new Reader(dba,"R2").start();
    }
    
}

class Writer extends Thread {
    private DatabaseAccess dba;
    
    public Writer(DatabaseAccess dba, String name) {
        super(name);
        this.dba=dba;
    }
    
    public void run() {
        try {
            do {
                dba.startWrite();
                System.out.println(getName()+": ACCESSO WRITE");
                //Thread.sleep(1000);
                dba.endWrite();
                System.out.println(getName()+": NON ACCESSO WRITE");
                //Thread.sleep(1000);
            } while(true);
        } catch(InterruptedException e) {
        }
    }
}

class Reader extends Thread {
    private DatabaseAccess dba;
    public Reader(DatabaseAccess dba, String name) {
        super(name);
        this.dba=dba;
    }
    
    public void run() {
        try {
            do {
                dba.startRead();
                System.out.println(getName()+": ACCESSO READ");
                //Thread.sleep(1000);
                dba.endRead();
                Thread.yield();
                System.out.println(getName()+": NON ACCESSO READ");
                //Thread.sleep(1000);
            } while(true);
        }
        catch(InterruptedException e){
            
        }
    }
}